.release:
  stage: release

.release_development:
  only:
    refs:
    - merge_requests@gitlab-org/ci-cd/runner-release-helper

.release_beta:
  only:
    refs:
    - main@gitlab-org/ci-cd/runner-release-helper
    - /\Av[0-9]+\.[0-9]+\.[0-9]+-rc[0-9]+\Z/@gitlab-org/ci-cd/runner-release-helper

.release_stable:
  only:
    refs:
    - /\Av[0-9]+\.[0-9]+\.[0-9]+\Z/@gitlab-org/ci-cd/runner-release-helper

.release_gcs_base:
  before_script:
  - gcloud auth activate-service-account --key-file "${GCP_SERVICE_KEY_FILE}"
  - gcloud config set project ${GCP_PROJECT_ID}
  only:
    variables:
    - $GCS_BUCKET
    - $GCS_PATH

.release_gcs:
  extends:
  - .release_gcs_base
  script:
  - make release_gcs

.remove_release_gcs:
  extends:
  - .release_gcs_base
  script:
  - make remove_gcs_release
  when: manual

release development GCS:
  extends:
  - .release
  - .release_development
  - .release_gcs
  environment:
    name: development/GCS/${CI_COMMIT_REF_NAME}
    url: https://storage.googleapis.com/${GCS_BUCKET}/${GCS_PATH}/${CI_COMMIT_REF_NAME}/index.html
    on_stop: stop release development GCS

stop release development GCS:
  extends:
  - .release
  - .release_development
  - .remove_release_gcs
  environment:
    name: development/GCS/${CI_COMMIT_REF_NAME}
    action: stop

release beta GCS:
  extends:
  - .release
  - .release_beta
  - .release_gcs
  environment:
    name: beta/GCS
    url: https://storage.googleapis.com/${GCS_BUCKET}/${GCS_PATH}/${CI_COMMIT_REF_NAME}/index.html

release stable GCS:
  extends:
  - .release
  - .release_stable
  - .release_gcs
  environment:
    name: stable/GCS
    url: https://storage.googleapis.com/${GCS_BUCKET}/${GCS_PATH}/${CI_COMMIT_REF_NAME}/index.html
